import asyncio
from pyrogram.types import InlineKeyboardMarkup, InlineKeyboardButton
from pyrogram.errors import FloodWait

from .helpers import encode


async def new_post(client, message):
    db_channel = await client.get_chat(-1001371272480)
    converted_id = message.message_id * abs(db_channel.id)
    string = f"get-{converted_id}"
    base64_string = await encode(string)
    link = f"https://t.me/OTHShareFileBot?start={base64_string}"
    reply_markup = InlineKeyboardMarkup([[InlineKeyboardButton("🔁 Share URL", url=f'https://telegram.me/share/url?url={link}')]])
    try:
        await message.edit_reply_markup(reply_markup)
    except Exception as e:
        print(e)
        pass


async def channel_post(client, message):
    db_channel = await client.get_chat(-1001371272480)
    reply_text = await message.reply_text("Mohon tunggu...!")
    try:
        post_message = await message.copy(chat_id=db_channel.id, caption="")
    except FloodWait as e:
        await asyncio.sleep(e.x)
        post_message = await message.copy(chat_id=db_channel.id, caption="")
    except Exception as e:
        print(e)
        await reply_text.edit_text(f"**ERROR**\n\n`{str(e)}`")
        return
    converted_id = post_message.message_id * abs(db_channel.id)
    string = f"get-{converted_id}"
    base64_string = await encode(string)
    link = f"https://t.me/OTHShareFileBot?start={base64_string}"

    reply_markup = InlineKeyboardMarkup([[InlineKeyboardButton("🔁 Share URL", url=f"https://telegram.me/share/url?url={link}")]])
    await reply_text.edit(f"**Link**\n\n`{link}`", disable_web_page_preview=True)
    await post_message.edit_reply_markup(reply_markup)
    await message.delete()
