import os
import asyncio

from pyrogram.types import InlineKeyboardMarkup, InlineKeyboardButton
from pyrogram.errors import FloodWait
from .helpers import (
    Text,
    encode,
    decode,
    get_messages,
)


async def start_command(client, message):
    text = message.text
    if len(text) > 7:
        try:
            base64_string = text.split(" ", 1)[1]
        except:
            return
        string = await decode(base64_string)
        argument = string.split("-")
        if len(argument) == 3:
            try:
                start = int(int(argument[1]) / abs(client.db_channel.id))
                end = int(int(argument[2]) / abs(client.db_channel.id))
            except:
                return
            if start <= end:
                ids = range(start,end+1)
            else:
                ids = []
                i = start
                while True:
                    ids.append(i)
                    i -= 1
                    if i < end:
                        break
        elif len(argument) == 2:
            try:
                ids = [int(int(argument[1]) / abs(client.db_channel.id))]
            except:
                return
        temp_msg = await message.reply("`Mohon tunggu...`")
        try:
            messages = await get_messages(client, ids)
        except:
            await message.reply_text("**Ada yang salah!**")
            return
        await temp_msg.delete()

        for msg in messages:

            try:
                await msg.copy(chat_id=message.from_user.id, caption=Text.KET, reply_markup=InlineKeyboardMarkup(Text.prem_buttons), protect_content=True)
                await asyncio.sleep(0.5)
            except FloodWait as e:
                await asyncio.sleep(e.x)
                await msg.copy(chat_id=message.from_user.id, caption=Text.KET, reply_markup=InlineKeyboardMarkup(Text.prem_buttons), protect_content=True)
            except:
                pass
        return
    else:
        await message.reply_text(
            Text.START.format(message.from_user.mention),
            reply_markup=InlineKeyboardMarkup(Text.start_buttons),
            disable_web_page_preview=True,
            protect_content=True,
        )
        return
